/**
 * Created by sinrst on 9/13/2016.
 */
jQuery.sap.declare("sas.dabt.configurations.proxy.SubjectGroupsProxy");
jQuery.sap.require("sas.dabt.common.util.ErrorUtil");
sas.dabt.configurations.proxy.SubjectGroupsProxy = {
    deploySubjectGroups: function(uri){
        var deferred = $.Deferred();
        sas.ajax(
            {
                type: 'POST',
                //url: "rest" + uri,
                url: uri,
                dataType: "json",
                accepts: { json: "application/json;charset=utf-8" },
                contentType: "application/json"
            }
        ).done(function (data) {
            deferred.resolve(data);
        }).fail(function (jqxhr) {
            jQuery.sap.log.error("Request Failed. Response text: " + jqxhr.responseText);
            deferred.reject(jqxhr);
        });
    },
    /*getDataPreparationCapabilities: function(){
        return sas.ajax({
            type:       "GET",
            url:        "rest/dataPreparation",
            dataType:   "json",
            async:      true,
            cache:      false,
            success: function (data, textStatus, jqXHR) {
            },
            error: function (jqXHR) {
                sas.dabt.common.util.ErrorUtil.handleAjaxRequestError(jqXHR);
            },
            complete: function(jqXHR) {
            }
        });
    },*/
    getConfigurationLinks: function(){
        return sas.ajax({
            type:       "GET",
            url:        "rest/configuration",
            dataType:   "json",
            async:      true,
            cache:      false,
            success: function (data, textStatus, jqXHR) {
            },
            error: function (jqXHR) {
                sas.dabt.common.util.ErrorUtil.handleAjaxRequestError(jqXHR);
            },
            complete: function(jqXHR) {
            }
        });
    },
    
    getProjects: function(){
        return sas.ajax({
            type:       "GET",
            url:        this.projectBaseURL,
            dataType:   "json",
            async:      true,
            cache:      false,
            success: function (data, textStatus, jqXHR) {
            },
            error: function (jqXHR) {
                sas.dabt.common.util.ErrorUtil.handleAjaxRequestError(jqXHR);
            },
            complete: function(jqXHR) {
            }
        });
    },
    getProject: function(projectLink){
        return sas.ajax({
            type:       "GET",
            //url:        "rest"+projectLink,
            url: projectLink,
            dataType:   "json",
            async:      true,
            cache:      false,
            success: function (data, textStatus, jqXHR) {
            },
            error: function (jqXHR) {
                sas.dabt.common.util.ErrorUtil.handleAjaxRequestError(jqXHR);
            },
            complete: function(jqXHR) {
            }
        });
    },
    getPurposeValues: function(purposeLink){
        return sas.ajax({
            type:       "GET",
            //url:        "rest"+purposeLink+"?sortBy=name&start=0&limit="+this.SIZE,
            url: purposeLink+"?sortBy=name&start=0&limit="+this.SIZE,
            dataType:   "json",
            async:      true,
            cache:      false,
            success: function (data, textStatus, jqXHR) {
            },
            error: function (jqXHR) {
                sas.dabt.common.util.ErrorUtil.handleAjaxRequestError(jqXHR);
            },
            complete: function(jqXHR) {
            }
        });
    },
    getPurpose:function(uri){
        return sas.ajax({
            type:       "GET",
            //url:        "rest"+uri,
            url: uri,
            dataType:   "json",
            async:      true,
            cache:      false,
            success: function (data, textStatus, jqXHR) {
            },
            error: function (jqXHR) {
                sas.dabt.common.util.ErrorUtil.handleAjaxRequestError(jqXHR);
            },
            complete: function(jqXHR) {
            }
        });
    },
    getSOAForPurpose: function(uri){
        return sas.ajax({
            type:       "GET",
           // url:        "rest"+uri,
            url: uri,
            dataType:   "json",
            async:      true,
            cache:      false,
            success: function (data, textStatus, jqXHR) {
            },
            error: function (jqXHR) {
                sas.dabt.common.util.ErrorUtil.handleAjaxRequestError(jqXHR);
            },
            complete: function(jqXHR) {
            }
        });
    },
    getSubjectGroupsForSOA: function(subjectGroupUri,SOAId){
        return sas.ajax({
            type:       "GET",
            //url:        "rest"+subjectGroupUri+"?applicableSubjectOfAnalyses.id="+SOAId+"&sortBy=name&start=0&limit="+this.SIZE,
            url: subjectGroupUri+"?applicableSubjectOfAnalyses.id="+SOAId+"&sortBy=name&start=0&limit="+this.SIZE,
            dataType:   "json",
            async:      true,
            cache:      false,
            success: function (data, textStatus, jqXHR) {
            },
            error: function (jqXHR) {
                sas.dabt.common.util.ErrorUtil.handleAjaxRequestError(jqXHR);
            },
            complete: function(jqXHR) {
            }
        });
    },
    getSubjectOfAnalysis: function(uri){
        return sas.ajax({
            type:       "GET",
            //url:        "rest"+uri+"?filter=and(eq(enabled,true),eq(availableForProjectDefinition,true))&sortBy=name&start=0&limit="+this.SIZE,
            url: uri+"?filter=and(eq(enabled,true),eq(availableForProjectDefinition,true))&sortBy=name&start=0&limit="+this.SIZE,
            dataType:   "json",
            async:      true,
            cache:      false,
            success: function (data, textStatus, jqXHR) {
            },
            error: function (jqXHR) {
                sas.dabt.common.util.ErrorUtil.handleAjaxRequestError(jqXHR);
            },
            complete: function(jqXHR) {
            }
        });
    },
    createProject: function(createProjectLink,project){
        return sas.ajax({
            type:       "POST",
            //url:        "rest"+createProjectLink,
            url: createProjectLink,
            contentType:   "application/vnd.sas.dabt.project+json",
            async:      true,
            cache:      false,
            data: JSON.stringify(project),
            success: function (data, textStatus, jqXHR) {
            },
            /*error: function (jqXHR) {
             sas.dabt.common.util.ErrorUtil.handleAjaxRequestError(jqXHR);
             },	*/
            complete: function(jqXHR) {
            }
        });
    }
};
