jQuery.sap.require("sas.csb.app.Constants");
jQuery.sap.require("sas.hc.ui.table.Table");
jQuery.sap.require("sas.hc.ui.table.Column");
jQuery.sap.require("sas.hc.m.ResponsiveToolbar");
jQuery.sap.require("sap.ui.model.resource.ResourceModel");
jQuery.sap.require("sas.cscommon.control.ui.ZeroState");
jQuery.sap.require("sas.cscommon.util.DataPreparationUtil");
jQuery.sap.require("sas.cscommon.util.FormatUtil");
jQuery.sap.require("sas.cscommon.util.JSONUtil");
jQuery.sap.require("sas.csb.common.util.ValidateUtil");
jQuery.sap.require("sas.hc.ui.objectmgr.ObjectManagerPage");
jQuery.sap.require("sas.hc.m.MessageToast");
jQuery.sap.require("sas.csb.common.to.Context");
jQuery.sap.require("sas.csb.common.to.Request");
jQuery.sap.require("sas.cscommon.util.MessageUtil");
jQuery.sap.require("sas.hc.m.ObjectMarker");

//jQuery.sap.require({modName:"sas.csb.common.view.MeasureCrossTab", type:"fragment"});

sap.ui.jsview("sas.csb.modelspecification.ModelList", {
	getControllerName : function() {
		return "sas.csb.modelspecification.ModelList";
	},

	createContent : function(controller) {
		this.rb = sap.ui.getCore().getLibraryResourceBundle("sas.csb.modelspecification");
		this.statisticalModel = this.rb.getText("csb.modelList.column.type.statisticalModel.txt");
		this.userDefinedScorecard = this.rb.getText("csb.modelList.column.type.userDefinedScorecard.txt");
		this.viya= this.rb.getText("csb.modelList.column.type.viya.txt");
		this.published = this.rb.getText("csb.modelList.column.status.published.txt");
		this.notPublished = this.rb.getText("csb.modelList.column.status.notPublished.txt");
		var createCapability = false;
		var loadCapability = false;
		var that = this;
		if(!!sas.csb.modelSpecificationJson){
			var link = sas.cscommon.util.JSONUtil.getLinkByRel(sas.csb.modelSpecificationJson.links,"createModels");
			if(!!link){
				createCapability = true;
			}
			var loadLink = sas.cscommon.util.JSONUtil.getLinkByRel(sas.csb.modelSpecificationJson.links,"externalModels");
			if(!!loadLink){
				loadCapability = true;
				this.loadUri = loadLink.uri;
			}
		}
		this.modelListZeroState = new sas.cscommon.control.ui.ZeroState({
			icon: createCapability ? sas.icons.HC.ZEROSTATEADD : undefined,
			text : this.rb.getText("dabt.model.noData.title")
		});
		this.modelListZeroState.addButton(new sas.hc.m.Button({
			id: this.createId("importModelBtn"),
			text: this.rb.getText("csb.importModel.button.txt"),
			design: sas.hc.m.Button.Design.Primary,
			enabled: true,
			visible:createCapability,
			press: [controller.onImportButtonPress, controller]
		}));
		this.modelListZeroState.addButton(new sas.hc.m.Button({
			id: this.createId("addModelBtn"),
			text: this.rb.getText("csb.createModel.button.txt"),
			enabled: true,
			visible:createCapability,
			press: [controller.onNewButtonPress, controller]
		}));

		/**
         * Commenting this for "CSB-27111: As analyst user, I should be able to do Back testing,
         * Model Monitoring of VDMML model in CS63 without using Model Manager"
         *
		this.modelListZeroState.addButton(this.createFileUploader(loadCapability, false));
		 */
		this.table = this.createModelTable(controller);
		this.tableView = new sas.hc.ui.objectmgr.TableObjectManagerView({
			content : this.table
		});
		this.tableView.getTable().setShowTableOptions(true);
		var actions = [];

		var refreshBtn = new sas.hc.m.Button({
			icon : sas.icons.HC.REFRESH,
			tooltip : this.rb.getText('dabt.refresh.tooltip.txt'),
			press : [ controller.onRefreshButtonPress, controller ]
		});

		var pageActions = [refreshBtn];
		var idx = 0;
		this.importButtonUI = new sas.hc.m.Button({
			icon : sas.icons.HC.IMPORT,
			tooltip : this.rb.getText("csb.importModel.tooltip.txt"),
			press : [ controller.onImportButtonPress, controller ],
			visible: createCapability
		});
		actions[idx++]=this.importButtonUI;
		this.newButtonUI = new sas.hc.m.Button({
			icon : sas.icons.HC.NEWSTARBURST,
			tooltip : this.rb.getText("csb.create.new.tooltip.txt"),
			press : [ controller.onNewButtonPress, controller ],
			visible: createCapability

		});
		actions[idx++]=this.newButtonUI;
		/**
		 * Commenting this for "CSB-27111: As analyst user, I should be able to do Back testing,
		 * Model Monitoring of VDMML model in CS63 without using Model Manager"
		 *
		this.fileUploader = this.createFileUploader(loadCapability, true);
		actions[idx++]=this.fileUploader;
		 */
		/* this.fileUploader.addEventDelegate({
			onAfterRendering: function() {
				this.fileUploader.oFileUpload.accept = ".zip";
			}
		 },this); */
		actions[idx++] =new sas.hc.ui.objectmgr.HeaderDivider();
		this.championButton = new sas.hc.m.ToggleButton({
			icon: sas.icons.HC.CHAMPION,
			visible:createCapability,
			enabled : false,
			tooltip : this.rb.getText('dabt.champion.tooltip.txt'),
			press : [ this.markChampionButtonPress, this ]
		});
		actions[idx++] = this.championButton;
		//----------------------------------------------------------
		this.openButtonUI = new sas.hc.m.Button({
			icon : sas.icons.HC.OPEN,
			enabled : false,
			tooltip : this.rb.getText('dabt.open.tooltip.txt'),
			press : [ this.onOpenButtonPress, this ]
		});
		actions[idx++] = this.openButtonUI;
		this.exportButton = new sas.hc.m.Button({
			icon : sas.icons.HC.EXPORT,
			enabled : false,
			tooltip : this.rb.getText('dabt.export.tooltip.txt'),
			press: [this.onExportButtonPress, this],
			visible: false
		});
		actions[idx++] = this.exportButton;
		this.downloadDS2Button = new sas.hc.m.Button({
			icon : sas.icons.HC.DOWNLOAD,
			enabled : false,
			tooltip : this.rb.getText("dabt.downloadDS2.tooltip.txt"),
			press: [this.onDownloadDS2ButtonPress, this],
			visible: false
		});
		actions[idx] = this.downloadDS2Button;
		this.objectManager = new sas.hc.ui.objectmgr.ObjectManagerPage({
			eventChannel : sas.csb.app.EventBusConstants.MODELSPECIFICATION_EVENT_CHANNEL,
			busyIndicatorDelay : 0,
			viewActions : actions,
			headerActions : pageActions,
			views:[this.tableView],
			newPageFunction : $.proxy(controller.getViewForItem, controller),
			openItem : [ this.onOpenItem, this ],
			selectionChange : [ this.onRowSelectionChange, this ],
			searchFieldFilterMode:false
		});

		this.objectManager.addStyleClass("csbObjectManagerPage");
		this.objectManager.searchField.setPlaceholder(this.rb.getText("dabt.placeholder.search.txt"));
		this.objectManager.setTitle(this.rb.getText('dabt.modelList.header.txt'));
		this.searchFlag = false;
		this.objectManager.searchField.attachSearch(function (oEvent) {
			var sValue = oEvent.getParameter("query");
			var displayFilter = new sap.ui.model.Filter("name", sap.ui.model.FilterOperator.Contains, sValue);
			that.table.getBinding("rows").filter(displayFilter);
			if (sValue && sValue.length > 0){
				that.searchFlag = true;
			}else{
				that.searchFlag = false;
			}
		});
		this.objectNavigatorUI = new sas.hc.ui.objectmgr.ObjectNavigator({
			pages : this.objectManager,
			height : "100%",
			width : "100%"
		});
		return this.objectNavigatorUI;

	},
	createFileUploader: function(visible,iconOnly){
		var that = this;
		var fileUploader = new sas.hc.ui.unified.FileUploader({
			//id: this.createId("zeroState-fileUploader"),
			sendXHR: true,
			useMultipart:true,
            uploadUrl: this.loadUri,                                                        // URL to submit the form to
            multiple:true,                                                                  // upload multiple files
            name: "externalModelFiles",                      								// name of the input type=file element within the form
            buttonOnly: true,                                                               // show the Browse button without the Input control
            //icon: sas.icons.HC.LOAD,                                                        // show an icon on the Browse button
            iconOnly: iconOnly,                                                                 // comment out this line to show the button rather than icon
            tooltip: that.rb.getText("csb.fileUploader.tooltip.txt"),   // important to set the tooltip especially when just the icon shows
			buttonText: that.rb.getText("csb.fileUploader.tooltip.txt"),
			uploadOnChange: true,
			fileType:["zip"],
			visible:visible,
			sameFilenameAllowed:true,
			maximumFileSize:20,
			fileSizeExceed:function (oEvent) {
				var failedModels = oEvent.getParameter("files");
				that.showFileSizeError(failedModels);
			}, 
			filesSelected: [ that.onFilesSelected, that],
			typeMissmatch: function(e){
				sas.hc.m.MessageDialog.error({
					title: that.rb.getText("csb.loadViyaModels.title.txt"),
					text: that.rb.getText("csb.loadViyaModels.error.typeMismatch.txt")
				});
			},
			uploadProgress: function(e){
				
				if(!that.busyDialog){
					that.busyDialog = new sas.hc.m.BusyDialog({
						title: that.rb.getText("csb.loadViyaModels.busy.txt"),
						showCancelButton: false
					});
				}
				that.busyDialog.open();
				},
			uploadComplete:[ that.onUploadComplete, that] 
		});
		if(iconOnly){
			fileUploader.setIcon(sas.icons.HC.LOAD);
			//fileUploader.setIconOnly(iconOnly);
		}
		fileUploader.addEventDelegate({
			onAfterRendering: function() {
				fileUploader.oFileUpload.accept = ".zip";
			}
		 })
		return fileUploader;
	},
	 showFileSizeError: function(models){
		var title = this.rb.getText("csb.loadViyaModels.title.txt");
		var msg;
		if(models.length > 1){
		msg = this.rb.getText("csb.loadViyaModels.fileSize.error.multiple.txt");
		}else{
			msg = this.rb.getText("csb.loadViyaModels.fileSize.error.single.txt");
		}
		sas.hc.m.MessageDialog.error({
			title: title,
			text: msg
		});
	},
	onFilesSelected: function (oEvent) {
		var that = this;
		that.selectedFiles = oEvent.getParameter("files");
		var failedModels = [];
		var fMaxSize = 20, //in MB
		fileSizeExceeded = false;
		for(var i = 0; i<that.selectedFiles.length; i++ ){
		fileSizeExceeded = that.selectedFiles[i].maxFileSizeExceeded;
		if(fileSizeExceeded){
			break;                //break out of loop even if single file exceeds size limit.
		}
		}
		if(fileSizeExceeded){
			for (var j = 0; j < that.selectedFiles.length; j++) {
				failedModels.push(that.selectedFiles[j].value.name);
			}
			oEvent.getSource().fireFileSizeExceed({"files": failedModels});
			
		}else{ //if single files pass the size criteria check for cumulative size.
			var cumulativeSize = 0;
			for (var k = 0; k < that.selectedFiles.length; k++) {
				cumulativeSize+=that.selectedFiles[k].value.size;
				failedModels.push(that.selectedFiles[k].value.name);
			}
			cumulativeSize = (cumulativeSize / 1024)/1024;
			if(cumulativeSize > fMaxSize){
				oEvent.getSource().fireFilesSelected({"files": failedModels});
			}
		}
	},
	onUploadComplete: function (e) {
		var that = this;
		if (that.busyDialog) {
			that.busyDialog.close();
		}
		var status = e.getParameter("status");
		var responseData = JSON.parse(e.getParameter("responseRaw"));
		var title = that.rb.getText("csb.loadViyaModels.title.txt");
		var msg;
		var failedModels = [];
		var showError = function(models){
			var failedFiles = "";
			if(models.length > 1){
				for (var i = 0; i < models.length; i++) {
					failedFiles += " - "+models[i] + "\n";
				}
			msg = that.rb.getText("csb.loadViyaModels.error.multiple.fmt",failedFiles);
			}else{
				msg = that.rb.getText("csb.loadViyaModels.error.single.fmt",models[0]);
			}
			sas.hc.m.MessageDialog.error({
				title: title,
				text: msg
			});
		};
		if (status === 400) {
			for (var i = 0; i < that.selectedFiles.length; i++) {
				failedModels.push(that.selectedFiles[i].value.name);
			}
			showError(failedModels);
		} else if(status === 200){
			for(var j = 0; j<responseData.items.length; j++){
				var item = responseData.items[j];
				if(item.httpStatusCode === 400){
					failedModels.push(that.selectedFiles[j].value.name);
				}
			}
			if(failedModels.length === 0){
			if(that.selectedFiles.length >1){
				msg = that.rb.getText("csb.loadViyaModels.success.multiple.txt");
			}else{
				msg = that.rb.getText("csb.loadViyaModels.success.single.txt");
			}
			sas.cscommon.util.MessageUtil.showInformationMessageBox(msg,title);
			}else{
				showError(failedModels);
			}
			
		}else if(status === 500){
			msg = that.rb.getText("csb.loadViyaModels.system.error.txt");
			sas.hc.m.MessageDialog.error({
				title: title,
				text: msg
			});
		}
	},
	createModelTable : function(controller) {
		var table = new sas.hc.ui.table.Table({
			id : this.createId("modelList-table"),
			minColumnWidth: 75,
			enableColumnReordering : false,
			showColumnVisibilityMenu : true,
			visibleRowCountMode : sap.ui.table.VisibleRowCountMode.Auto,
			minAutoRowCount : 1,
			selectionBehavior : sap.ui.table.SelectionBehavior.Row,
			selectionMode : sap.ui.table.SelectionMode.MultiToggle,
			noData:" "
		});

		this.addModelTableColumns(controller, table);
		table.setShowTableOptions(true);
		return table;

	},
	updateZeroState: function (rowCount) {
		if (rowCount === 0) {
			if (this.searchFlag) { // Zero state after search
				this.objectManager.setGettingStartedViewVisible(false);
				this.table.setNoData(new sas.cscommon.control.ui.ZeroState({
					title: this.rb.getText("dabt.model.noData.found.txt")
				}));
			} else {
				if (!this.createCapability) { // If no create capability don't show create button.
					this.objectManager.setGettingStartedView(this.modelListZeroState);
				}
				this.objectManager.setGettingStartedViewVisible(true);
				this.objectManager.setGettingStartedTitle(this.rb.getText("dabt.modelList.header.txt"));
			}
		}else{
			//FIXID S1405101: model list refresh issue - In case of zero state.
			this.objectManager.setGettingStartedViewVisible(false);
		}
	},
	markChampionButtonPress: function (oEvt) {
		var selectedItems = this.objectManager.getSelectedItems();
		var itemCount = selectedItems.length;
		if (itemCount > 0) {
			var selectedItem = selectedItems[0];
			if (!!selectedItem) {
				var links = selectedItem.links;
				if (links && links.length > 0) {
					var championLink = sas.cscommon.util.JSONUtil.getLinkByRel(links, "partialUpdate");
					if (championLink) {
						this.setBusy(true);
						var oData = {
							"op": "replace",
							"path": "/champion",
							"value": this.championButton.getPressed()
						};
						this.getController().doUpdate(championLink,oData);
					}
				}

			}
		}
	},

	onAfterCreate: function (context) {
		var response = context.getResponse(),
			request = context.getRequest(),
			selectedItem,
			links;

		if(response.getResponseType() === sas.csb.app.AjaxConstants.CREATE_AUDITABILITY_REPORT ){
			selectedItem = request.getData();
			links = selectedItem.links;
			var exportLink = sas.cscommon.util.JSONUtil.getLinkByRel(links, sas.csb.app.relConstants.AUDITABILITY_REPORT);

			// Download the generated file in the same window
			window.open(exportLink.href, "_self");
		}

		if(response.getResponseType() === sas.csb.app.AjaxConstants.CREATE_DS2_REPORT ){
			selectedItem = request.getData();
			links = selectedItem.links;
			var downloadDS2Link = sas.cscommon.util.JSONUtil.getLinkByRel(links, sas.csb.app.relConstants.DS2_REPORT);

			// Download the generated file in the same window
			window.open(downloadDS2Link.href, "_self");
		}
	},

	onAfterPatch: function (oResponse, oRequestControl) {
		this.setBusy(false);
		this.handleAfterFetch(true);
	},

	onAfterError: function (context, jqxhr) {
		var response = context.getResponse();
		var request = context.getRequest();
		var data = request.getData();

		if(response.getResponseType() === sas.csb.app.AjaxConstants.CREATE_AUDITABILITY_REPORT ){
			sas.cscommon.util.MessageUtil.showErrorMessageBox(this.rb.getText("csb.modelSpecification.exportReport.error.message.txt", [data.name]),
				this.rb.getText("csb.modelSpecification.exportReport.error.message.title.txt"));
		}

		if(response.getResponseType() === sas.csb.app.AjaxConstants.CREATE_DS2_REPORT ){
			sas.cscommon.util.MessageUtil.showErrorMessageBox(this.rb.getText("csb.modelSpecification.downloadDS2.error.message.txt", [data.name]),
				this.rb.getText("csb.modelSpecification.downloadDS2.error.message.title.txt"));
		}
	},

	onError: function (errorCode, errorMsg) {

		this.setBusy(false);
		var that = this;
		var closeHandlerFn = function(){
			that.handleAfterFetch();
		};
		if (errorCode !== 200) {
			if (errorCode === 404) {
				sas.cscommon.util.MessageUtil.showErrorMessageBox(this.rb.getText('modelspecification.modeldetails.modelParameters.notFound.message.txt'), this.rb.getText('modelspecification.errorMsg.title.txt'),null,closeHandlerFn);
			} else if (errorCode === 412) {
				sas.cscommon.util.MessageUtil.showErrorMessageBox(this.rb.getText('modelspecification.modeldetails.champion.modifiedDateChanged.message.txt'), this.rb.getText('modelspecification.errorMsg.title.txt'),null,closeHandlerFn);
			} else if (errorCode === 409) {
				sas.cscommon.util.ErrorUtil.handleAjaxRequestError(jqxhr, this.rb.getText('modelspecification.errorMsg.title.txt'));
			} else {
				sas.cscommon.util.ErrorUtil.handleAjaxRequestError(jqxhr);
			}
		} else {
			sas.cscommon.util.ErrorUtil.handleAjaxRequestError(jqxhr);
		}

	},
	handleAfterFetch: function () {
		this.championButton.setPressed(false);
		this.championButton.setEnabled(false);
		var model = this.table.getModel();
		if (model) {
			model.clearData();
			this.table.clearSelection();
		}
		this.championButton.setTooltip(this.rb.getText("dabt.champion.tooltip.txt"));
	},
	onRowSelectionChange: function (oEvt) {
		var selectedItems = oEvt.oSource.getSelectedItems();
		var selectedRowCount = selectedItems.length;
		var enabledFlag = true;
		if (selectedRowCount > 0) {
			var filteredModels = selectedItems.filter(function(model){
				return (model.status === "importInProgress" || model.status === "importFailed");
			});
			if(filteredModels.length > 0){
				enabledFlag = false;
			}
			var champion = false;
			if(selectedRowCount === 1){
				var selectedModel = selectedItems[0];
				if (selectedModel){
					champion = selectedModel.champion;
					var tooltip = champion ? this.rb.getText("dabt.clearChampion.tooltip.txt") : this.rb.getText("dabt.champion.tooltip.txt");
					this.championButton.setTooltip(tooltip);
					this.downloadDS2Button.setEnabled(enabledFlag && (selectedModel.source!=="viya"));
				}
				this.championButton.setPressed(!!champion);
				this.championButton.setEnabled(true && enabledFlag);
				}else{
				this.championButton.setTooltip(this.rb.getText("dabt.champion.tooltip.txt"));
				this.championButton.setPressed(false);
				this.championButton.setEnabled(false);
				this.downloadDS2Button.setEnabled(false);
			}

			this.exportButton.setEnabled(selectedRowCount === 1 && enabledFlag);
			this.openButtonUI.setEnabled(true && enabledFlag);
			
		} else {
			this.championButton.setTooltip(this.rb.getText("dabt.champion.tooltip.txt"));
			this.championButton.setEnabled(false);
			this.exportButton.setEnabled(false);
			this.downloadDS2Button.setEnabled(false);
			this.openButtonUI.setEnabled(false);
		}
	},
	onOpenButtonPress: function () {
		var selectedItems = this.objectManager.getSelectedItems();
		var itemCount = selectedItems.length;
		if (itemCount > 0) {
			this.setBusyIndicatorDelay(0);
			for (var i = 0; i < itemCount; i++) {
				var selectedItem = selectedItems[i];
				if (!!selectedItem) {
					this.openItem(selectedItem);
				}
			}
		}
		//this.objectManager.setEditMode(false);
	},

	onOpenItem: function (oEvent) {
		var item = oEvent.getParameter("item");
		if(item.status === "importInProgress"){
			sas.cscommon.util.MessageUtil.showErrorMessageBox(this.rb.getText("openModel.importInProgress.error.txt"), this.rb.getText("modelList.openModel.title.txt"));
		}else if(item.status === "importFailed"){
			sas.cscommon.util.MessageUtil.showErrorMessageBox(this.rb.getText("openModel.importFailed.error.txt"), this.rb.getText("modelList.openModel.title.txt"));
		}
		else{
		item.editMode = true;
		this.openItem(item);
		}
	},
	openItem: function (item) {
		if (!item.id) {
			// generate an ID for the new item
			item.id = jQuery.sap.uid();
			//Set default name in case of no name
			if (!item.name) {
				item.name = this.createDefaultName(item);
			}
			this.objectManager.addOpenItem(item);
			this.objectManager.showItem(item);

		}
		if (this.objectManager.isItemOpen(item)) {
			// item is already open, so just show it if requested			
			this.objectManager.showItem(item);
		} else {
			this.getController().loadItem(item);
		}
	},
	validateDirtyState: function (oEvent) {
		var dirty = false;
		var objectNavigator = this.objectNavigatorUI;
		var pages = objectNavigator.getAllContentPages(),
			i;
		if (pages && pages.length > 0) {
			for ( i = 0; i < pages.length; i++) {
				var page = pages[i];
				if (page && page.getDirty()) {
					dirty = true;
					break;
				}
			}
		}
		var dirtyState = dirty ? sas.hc.ui.commons.LeftNavItem.STATE_DIRTY : undefined;
		var lefNavs = sas.ui.leftNav.getModel();
		if (lefNavs && lefNavs.length > 0) {
			for ( i = 0; i < lefNavs.length; i++) {
				var lefNav = lefNavs[i];
				if (lefNav && lefNav.getId() === sas.csb.app.Constants.Modeling_Specification) {
					lefNav.setState(dirtyState);
				}
			}
		}
		var appDirtyState = false;
		var data = oEvent.getParameters();
		var validProp = data.hasOwnProperty('appDirty');
		if (validProp) {
			appDirtyState = data.appDirty;
			if (!appDirtyState) {
				appDirtyState = dirty;
			}
		} else {
			appDirtyState = dirty;
		}
		sas.csb.common.util.ValidateUtil.updateAppSwitcherDirtyState(appDirtyState);
		var doClose = data.doClose;
		if (doClose) {
			doClose();
		}

	},
	createStatusColumn:function(){
		var that = this;
		var column = new sas.hc.ui.table.Column({
			label : new sas.hc.m.Label({
				text : this.rb.getText("csb.modelList.column.status.txt")
			}),
			template: new sas.hc.m.ObjectMarker({
				type: {
					path: "status",
					formatter: function (value) {
						var type = sap.m.ObjectMarkerType.NeutralStatus;
						if (value === "importFailed") {
								type = sap.m.ObjectMarkerType.ErrorStatus
						}else if (value === "importInProgress") {
								type = sap.m.ObjectMarkerType.AnimatedProgressIndicator
						}
					return type;
					}
				},
				active: false,
				visibility: {
					path: "status",
					formatter: function (value) {
						var visibility = sap.m.ObjectMarkerVisibility.TextOnly;
						if (value !== "published" && value!== "notPublished") {
								visibility = sap.m.ObjectMarkerVisibility.IconAndText
						}
						return visibility;
					}
				},
				additionalInfo: {
					path: "status",
					formatter: function (value) {
						var status = "";
							if (value === "published") {
								status = that.published;
							} else if (value === "notPublished") {
								status = that.notPublished;
							}else if (value === "importInProgress") {
								status = that.rb.getText("csb.model.status.inProcess.txt");
							}else{
								status = that.rb.getText("csb.model.status.importFailed.txt");
							}
						return status;
					}
				}
			}),
			sortProperty : "status",
			visible : true,
			width:"10rem"
		});
		return column;
	},
	addModelTableColumns : function(oController, table) {
		var that = this;
		var idColumn = new sas.hc.ui.table.Column({
			id : this.createId("modelList-idColumn"),
			label : new sas.hc.m.Label({
				text : this.rb.getText('dabt.model.id.txt')
			}),
			template : new sas.hc.m.Text({
				text : "{modelId}"
			}),
			sortProperty : "id",
			visible : true,
			width:"5rem"
		});
		idColumn.fnSortCompare = this.compareIntegers;
		table.addColumn(idColumn);
		table.addColumn(new sas.hc.ui.table.Column({
			label:new sas.hc.m.Label({text: this.rb.getText("csb.modelList.column.champion.txt"), textAlign:"Center"}),
			template: new sas.hc.ui.core.Icon({
				src: sas.icons.HC.CHAMPION,
				tooltip:this.rb.getText("csb.modelList.column.champion.tip.txt"),
				alt:this.rb.getText("csb.modelList.column.champion.tip.txt"),
				decorative : false,
				useIconTooltip : true,
				visible:{
					path:"champion",
					formatter:function(champion){
						return !!champion;
					}
				}
			}),
			sortProperty: "champion",
			visible:true,
			hAlign: "Center",
			width:"5rem"
		}));
		table.addColumn(new sas.hc.ui.table.Column({
			label : new sas.hc.m.Label({
				text : this.rb.getText("dabt.model.name.txt")
			}),
			template : new sas.hc.m.Text({
				text : "{name}"
			}),
			sortProperty : "name",
			visible : true,
			width:"10rem"
		}));
		table.addColumn(new sas.hc.ui.table.Column({
			label : new sas.hc.m.Label({
				text : this.rb.getText("csb.modelList.column.type.txt")
			}),
			template: new sas.hc.m.Text({
				text: {
					path: "source",
					formatter: function (value) {
						var type = "";
							if (value === "registered") {
								type = that.statisticalModel;
							} else if (value === "userDefinedScorecard") {
								type = that.userDefinedScorecard;
							} else if( value === "viya"){
								type = that.viya;
							}
						return type;
					}
				}
			}),
			sortProperty : "source",
			visible : true,
			width:"10rem"
		}));
		table.addColumn(this.createStatusColumn());
		table.addColumn(new sas.hc.ui.table.Column({
			label : new sas.hc.m.Label({
				text : this.rb.getText("dabt.model.project.txt")
			}),
			template : new sas.hc.m.Text({
				text : "{projectName}"
			}),
			sortProperty : "projectName",
			visible : true,
			width:"10rem"
		}));
		table.addColumn(new sas.hc.ui.table.Column({
			label : new sas.hc.m.Label({
				text : this.rb.getText("csb.modelList.column.targetVariable.txt")
			}),
			template : new sas.hc.m.Text({
				text : "{targetVariableName}"
			}),
			visible : true,
			width:"10rem"
		}));
		table.addColumn(new sas.hc.ui.table.Column({
			label : new sas.hc.m.Label({
				text : this.rb.getText("csb.modelList.column.purpose.txt")
			}),
			template : new sas.hc.m.Text({
				text : "{purposeName}"
			}),
			sortProperty : "purposeName",
			visible : true,
			width:"10rem"
		}));
		table.addColumn(new sas.hc.ui.table.Column({
			label : new sas.hc.m.Label({
				text : this.rb.getText("dabt.model.subject.analysis.txt")
			}),
			template : new sas.hc.m.Text({
				text : "{subjectOfAnalysisName}"
			}),
			sortProperty : "subjectOfAnalysisName",
			visible : true,
			width:"10rem"
		}));
		table.addColumn(new sas.hc.ui.table.Column({
			label : new sas.hc.m.Label({
				text : this.rb.getText("csb.modelList.column.subjectGroup.txt")
			}),
			template : new sas.hc.m.Text({
				text : "{subjectGroupName}"
			}),
			sortProperty : "subjectGroupName",
			visible : false,
			width:"10rem"
		}));
		table.addColumn(new sas.hc.ui.table.Column({
			label : new sas.hc.m.Label({
				text : this.rb.getText("dabt.description.txt")
			}),
			template : new sas.hc.m.Text({
				text : "{description}"
			}),
			sortProperty : "description",
			visible : false,
			width:"15rem"
		}));
		var createdDateColumn = new sas.hc.ui.table.Column({
			label : new sas.hc.m.Label({
				text : this.rb.getText("dabt.createdDate.txt")
			}),
			template : new sas.hc.m.Text().bindProperty("text", {
				path : "creationTimeStamp",
				formatter : function(obj) {
					return sas.cscommon.util.FormatUtil.formatDateTime(obj);
				}

			}),
			sortProperty : "creationTimeStamp",
			visible : false,
			width:"15rem"
		});
		table.addColumn(createdDateColumn);

		var lastModifiedColumn = new sas.hc.ui.table.Column({
			label : new sas.hc.m.Label({
				text : this.rb.getText("dabt.modifiedDate.txt")
			}),
			template : new sas.hc.m.Text().bindProperty("text", {
				path : "modifiedTimeStamp",
				formatter : function(obj) {
					return sas.cscommon.util.FormatUtil.formatDateTime(obj);
				}

			}),
			sortProperty : "modifiedTimeStamp",
			visible : false,
			width:"15rem"
		});
		table.addColumn(lastModifiedColumn);
	},
	setAndBindModel : function(model, bindPath) {

		this.table.setModel(model);
		//Initially sort the table based on modified timestamp and id
		var sorter = [
			new sap.ui.model.Sorter("modifiedTimeStamp", false),
			new sap.ui.model.Sorter("id", false)
		]
		this.table.bindRows(bindPath,sorter);

		// Select the first row in the table
		//this.table.setSelectedIndex(0);
	},

	resetSearchField : function() {
		if(this.objectManager) {
			this.objectManager.searchField.setValue("");
		}
	},
	onMeasureButtonPress: function(){
		var that = this;
		that.setBusy(true);
		sas.ltjs.ltjsLoader.runWhenInitialized(function ()  {
			try{

				var MeasureDashBoardDialog = sap.ui.jsfragment("sas.csb.common.view.MeasureCrossTab", that.getController());
				MeasureDashBoardDialog.open();
				that.setBusy(false);
			}
			catch(e){
				that.setBusy(false);
			}
		});
	},
	onExportButtonPress: function(event) {
		var selectedItems = this.objectManager.getSelectedItems();
		var itemCount = selectedItems.length;

		if (itemCount > 0) {
			var selectedItem = selectedItems[0];
			if (selectedItem) {
				var links = selectedItem.links;
				var generateLink = sas.cscommon.util.JSONUtil.getUriByRel(links, sas.csb.app.relConstants.CREATE_AUDITABILITY_REPORT);

				var request = new sas.csb.common.to.Request(generateLink, selectedItem);
				var context = new sas.csb.common.to.Context(request);

				// Generate the model report
				this.getController().generateAuditabilityRport(context);

				// Enable the Export Report icon
				if(this.exportButton) {
					this.exportButton.setEnabled(false);
					// S1423081 : Clicking on 'Export model detail report' multiple times icon gives error
					// When the 'Download DS2 scoring code' icon or 'Export model detail report' icon is 
					// clicked multiple times in succession then multiple ajax requests goes for 
					// generation/downloading the report and those are resulted in an error.
					// So to prevent these consecutive Rest api calls the icons are disable for 1 second after clicking.
					this._timerIdExportButton = setTimeout(jQuery.proxy(this._enableExportReportAfterTimer, this), 1000);
				}

				//Show toast message
				sas.hc.m.MessageToast.show(this.rb.getText("csb.modelSpecification.exportReport.message.txt"));
			}
		}
	},

	onDownloadDS2ButtonPress: function(event) {
		var selectedItems = this.objectManager.getSelectedItems();
		var itemCount = selectedItems.length;

		if (itemCount > 0) {
			var selectedItem = selectedItems[0];
			if (selectedItem) {
				// Check if the model is not locked
				if(!selectedItem.registeredDate) {
					sas.cscommon.util.MessageUtil.showErrorMessageBox(this.rb.getText("csb.modelSpecification.downloadDS2.scorecardError.message.txt"),
						this.rb.getText("csb.modelSpecification.downloadDS2.error.message.title.txt"));
				} else {
					var links = selectedItem.links;
					var generateLink = sas.cscommon.util.JSONUtil.getUriByRel(links, sas.csb.app.relConstants.CREATE_DS2_REPORT);

					var request = new sas.csb.common.to.Request(generateLink, selectedItem);
					var context = new sas.csb.common.to.Context(request);

					// Generate the model report
					this.getController().generateDS2Report(context);

					// Enable the Download DS2 Code icon
					if(this.downloadDS2Button) {
						this.downloadDS2Button.setEnabled(false);
						// S1423081 : Clicking on 'Download DS2 scoring code' multiple times icon gives error
						// When the 'Download DS2 scoring code' icon or 'Export model detail report' icon is 
						// clicked multiple times in succession then multiple ajax requests goes for 
						// generation/downloading the report and those are resulted in an error.
						// So to prevent these consecutive Rest api calls the icons are disable for 1 second after clicking.
						this._timerIdDownloadDS2Button = setTimeout(jQuery.proxy(this._enableDownloadDS2AfterTimer, this), 1000);
					}

					//Show toast message
					sas.hc.m.MessageToast.show(this.rb.getText("csb.modelSpecification.downloadDS2.message.txt"));
				}
			}
		}
	},

	_enableDownloadDS2AfterTimer: function() {
		if(this.downloadDS2Button) {
			this.downloadDS2Button.setEnabled(true);
		}
	},

	_enableExportReportAfterTimer: function() {
		if(this.exportButton) {
			this.exportButton.setEnabled(true);
		}
	},

	destroy:function() {
		clearTimeout(this._timerIdDownloadDS2Button);
		clearTimeout(this._timerIdExportButton);
		if (this.tableView) {
			this.tableView.destroy();
		}
		if (this.objectManager) {
			this.objectManager.destroy();
		}
		if (this.modelListZeroState) {
			this.modelListZeroState.destroy();
		}
		this.objectNavigatorUI.destroy();
		sap.ui.core.mvc.JSView.prototype.destroy.apply(this, arguments);
	}

});