/**
 * SAS extension of TriStateCheckBoxRenderer for HTML Commons.
 * Copyright 2014 SAS Institute Inc.
 * All Rights Reserved.
 * @name sas.hc.ui.commons.TriStateCheckBoxRenderer
 */

jQuery.sap.declare("sas.hc.ui.commons.TriStateCheckBoxRenderer");
jQuery.sap.require("sap.ui.core.Renderer");
jQuery.sap.require("sap.ui.commons.TriStateCheckBoxRenderer");

sas.hc.ui.commons.TriStateCheckBoxRenderer = sap.ui.core.Renderer.extend(sap.ui.commons.TriStateCheckBoxRenderer);

/**
 * Implement hook-in function for sap.ui.commons.TriStateCheckBoxRenderer to render SAS icon.
 *
 * @param {sap.ui.core.RenderManager} oRm - The RenderManager that can be used for writing to the render output buffer.
 * @param (object) oControl - The TriStateCheckBox control
 * @override
 */
sas.hc.ui.commons.TriStateCheckBoxRenderer.renderCheckMarkIcon = function(oRm, oControl) {

    var selectedState = oControl.getSelectionState();

    if (selectedState === "Checked") {
        oRm.writeIcon(sas.icons.HC.CHECKMARK);
    } else if (selectedState === "Mixed") {
        oRm.write("<span class='sapUiIcon'></span>");
    }
};
