
	/* Post action after creating new model */
%macro dabt_new_model_wrapper(m_model_sk=, m_model_source_type_cd=, m_metadata_folder_path=, m_created_by_user=);
	
	%let m_model_sk = &m_model_sk;
	%let m_model_source_type_cd = %upcase(&m_model_source_type_cd);
	%let m_created_by_user = &m_created_by_user;
	
	%let m_tmp_lib = ;
	%let m_src_lib = ;
	%let m_log_path = ;
	
	%let m_scr_path = ;
	%let m_scoring_code_path = ;
	
	/* obtain the apdm library and log and scratch path and library */
	%dabt_assign_libs(tmp_lib=m_tmp_lib,
					 src_lib=m_src_lib, log_path= m_log_path,
					 m_workspace_type=CHRSTC, m_called_for_abt_processing_flg=N,
					 m_abt_or_template_sk=&m_model_sk., scr_path=m_scr_path,
					 scoring_code_path=m_scoring_code_path);
					 
	
	/* Start: update model_master: to be moved post new model creation */
	%let m_event_sk = ;
	%let m_apply_bld_dt_cap_outcm_var_flg = ;
	%let m_purpose_sk = ;
	%let m_level_sk = ;
	%let m_abt_time_grain_sk = ;
	%let m_abt_sk = ;
	%let m_actual_reqd_flg = ;
	%let m_target_period_cnt = ;
	proc sql noprint;
		select abt.event_sk, mat.apply_bld_dt_cap_var_act_flg, pm.purpose_sk, pm.level_sk,
			 abt.source_data_time_grain_sk, abt.abt_sk, mat.actual_required_flg 
			 ,abt.target_period_cnt
			into :m_event_sk, :m_apply_bld_dt_cap_outcm_var_flg, :m_purpose_sk, :m_level_sk, 
				:m_abt_time_grain_sk, :m_abt_sk, :m_actual_reqd_flg
				,:m_target_period_cnt
			
		from &m_src_lib..modeling_abt_master abt
			inner join &m_src_lib..model_x_modeling_abt mma
			on (abt.abt_sk = mma.abt_sk)
			inner join &m_src_lib..project_master pm
			on (abt.project_sk = pm.project_sk)
			inner join &m_src_lib..purpose_master prp
			on (pm.purpose_sk = prp.purpose_sk)
			inner join &m_src_lib..model_analysis_type_master mat
			on (prp.model_analysis_type_sk = mat.model_analysis_type_sk)
		where mma.model_sk = &m_model_sk.;
	quit;
	%let m_event_sk = &m_event_sk;
	%let m_apply_bld_dt_cap_outcm_var_flg = &m_apply_bld_dt_cap_outcm_var_flg;
	%let m_purpose_sk = &m_purpose_sk;
	%let m_level_sk = &m_level_sk;
	%let m_abt_time_grain_sk = &m_abt_time_grain_sk;
	%let m_abt_sk = &m_abt_sk;
	%let m_actual_reqd_flg = &m_actual_reqd_flg;
	%let m_target_period_cnt = &m_target_period_cnt;
	
	%let m_apply_oc_bsd_pst_impl_sbst_flg = ;
	proc sql noprint;
		select apply_oc_pst_impl_sbst_scr_flg
			into :m_apply_oc_bsd_pst_impl_sbst_flg
		from &m_src_lib..purpose_master pm, &m_src_lib..model_analysis_type_master mat
		where pm.model_analysis_type_sk = mat.model_analysis_type_sk
			and pm.purpose_sk = &m_purpose_sk;
	quit;
	%let m_apply_oc_bsd_pst_impl_sbst_flg = &m_apply_oc_bsd_pst_impl_sbst_flg;
	

	%if %kupcase("&m_target_period_cnt") eq "0" %then %do; /* i18nOK:Line */
		%let m_apply_bld_dt_cap_outcm_var_flg = N;
	%end;

	proc sql noprint ;
		update &m_src_lib..model_master
		set	apply_oc_bsd_pst_impl_sbst_flg = "&m_apply_oc_bsd_pst_impl_sbst_flg", /* i18nOK:Line */
			event_sk = &m_event_sk,
			apply_bld_dt_cap_outcm_var_flg = "&m_apply_bld_dt_cap_outcm_var_flg", /* i18nOK:Line */
			actual_reqd_flg = "&m_actual_reqd_flg" /* i18nOK:Line */
		where model_sk = &m_model_sk.;
	quit;
	/* End: update model_master */
	
	/* Start: Insert implicit variable for scoring and actual */
	/* Drop any existing temp tables */

	%if %sysfunc(exist(&m_tmp_lib..lst_impl_var_nm)) %then %do;
	proc sql noprint;drop table &m_tmp_lib..lst_impl_var_nm; quit;
	%end;
	%if %sysfunc(exist(&m_tmp_lib..lst_impl_var_sk)) %then %do;
	proc sql noprint;drop table &m_tmp_lib..lst_impl_var_sk; quit;
	%end;
	
	/* Get list of implicit variable name to be added for scoring/actual */
	proc sql noprint;
		create table &m_tmp_lib..lst_impl_var_nm as
		select vm.variable_column_nm, imp.applicable_for_scr_process_flg, imp.applicable_for_act_process_flg 
		from &m_src_lib..implicit_var_specification_dtl imp
			inner join &m_src_lib..variable_master vm
			on (imp.variable_sk = vm.variable_sk)
		where imp.purpose_sk = &m_purpose_sk 
				and imp.level_sk = &m_level_sk and imp.abt_time_grain_sk = &m_abt_time_grain_sk
				and (upcase(strip(imp.applicable_for_scr_process_flg)) = 'Y' or  /* i18nOK:Line */
					 upcase(strip(imp.applicable_for_act_process_flg)) = 'Y') ; /* i18nOK:Line */
	quit;
	
	/* Get list of implicit variable sk to be added for scoring/actual */
	proc sql noprint;
		create table &m_tmp_lib..lst_impl_var_sk as
		select mav.variable_sk, t1.applicable_for_scr_process_flg, t1.applicable_for_act_process_flg 
		from &m_tmp_lib..lst_impl_var_nm t1
			inner join &m_src_lib..variable_master vm
			on (t1.variable_column_nm = vm.variable_column_nm)
			inner join &m_src_lib..MODELING_ABT_X_VARIABLE mav
			on (vm.variable_sk = mav.variable_sk)
		where mav.abt_sk = &m_abt_sk;
	quit;
	
	/* insert the corresponding variable sk for scoring in MODEL_X_SCR_INPUT_VARIABLE. */
	proc sql noprint;
		insert into &m_src_lib..MODEL_X_SCR_INPUT_VARIABLE
			(MODEL_SK, VARIABLE_SK, SIGNIFICANT_VARIABLE_FLG, IMPLICIT_VARIABLE_FLG, CREATED_DTTM, CREATED_BY_USER)
		select &m_model_sk. as model_sk, t1.VARIABLE_SK, 'N' as SIGNIFICANT_VARIABLE_FLG, 'Y' as IMPLICIT_VARIABLE_FLG, /* i18nOK:Line */
			 %sysfunc(datetime()) as CREATED_DTTM, "&m_created_by_user" as CREATED_BY_USER /* i18nOK:Line */
		from &m_tmp_lib..lst_impl_var_sk t1
		where upcase(strip(t1.applicable_for_scr_process_flg)) = 'Y'; /* i18nOK:Line */
	quit;
		
	/* get variable sk of target variable for given a model. These records are already inserted by mid tier during new model step*/
	%let m_tgt_var_sk = .;
	proc sql noprint;
		select put(variable_sk,12.) into :m_tgt_var_sk 
		from &m_src_lib..MODEL_X_ACT_OUTCOME_VAR
		where model_sk = &m_model_sk;
	quit;
	%let m_tgt_var_sk = &m_tgt_var_sk;
	
	/* In case target variable is implicit variable then update the corresponding flag */
	proc sql noprint;	
		update &m_src_lib..MODEL_X_ACT_OUTCOME_VAR t1
			set IMPLICIT_VARIABLE_FLG = 'Y' /* i18nOK:Line */
			where t1.VARIABLE_SK in (select t2.VARIABLE_SK from &m_tmp_lib..lst_impl_var_sk t2 
									where  upcase(strip(t2.applicable_for_act_process_flg)) = 'Y') /* i18nOK:Line */
					and model_sk = &m_model_sk.;
	quit;
	
	/* insert the corresponding variable sk for actual in MODEL_X_ACT_OUTCOME_VAR. */
	proc sql noprint;
		insert into &m_src_lib..MODEL_X_ACT_OUTCOME_VAR
			(MODEL_SK, VARIABLE_SK, TARGET_VARIABLE_FLG, IMPLICIT_VARIABLE_FLG, CREATED_DTTM, CREATED_BY_USER)
		select &m_model_sk. as model_sk, t1.VARIABLE_SK, 'N' as TARGET_VARIABLE_FLG, 'Y' as IMPLICIT_VARIABLE_FLG, /* i18nOK:Line */
			 %sysfunc(datetime()) as CREATED_DTTM, "&m_created_by_user" as CREATED_BY_USER /* i18nOK:Line */
		from &m_tmp_lib..lst_impl_var_sk t1
		where upcase(strip(t1.applicable_for_act_process_flg)) = 'Y' and t1.variable_sk ne &m_tgt_var_sk; /* i18nOK:Line */
	quit;
	
	/*Start of Update tgt var sk*/
		
	%let m_bin_chrstc_sk_lst=.;
	proc sql;

	select 
		bin_chrstc_sk into  :m_bin_chrstc_sk_lst
				separated by ',' /* i18nOK:Line */
	from 
		&m_src_lib..mm_report_specification 
		inner join &m_src_lib..report_spec_x_bin_scheme 
			on ( mm_report_specification.report_specification_sk = report_spec_x_bin_scheme.report_specification_sk )
		inner join  &m_src_lib..bin_scheme_bin_chrstc_defn
			on (report_spec_x_bin_scheme.bin_analysis_scheme_sk = bin_scheme_bin_chrstc_defn.bin_analysis_scheme_sk)

	where mm_report_specification.model_sk=&m_model_sk. and report_specification_type_sk=1;

	quit;

	%let m_bin_chrstc_sk_lst = &m_bin_chrstc_sk_lst.;


	%let m_tgt_var_sk= .;
	proc sql;

	select 
		 variable_sk into :m_tgt_var_sk
	from 
		&m_src_lib..model_x_act_outcome_var
	where 
		model_x_act_outcome_var.model_sk=&m_model_sk.  and target_variable_flg="Y";   /* i18nOK:Line */

	quit;

	%let m_tgt_var_sk = &m_tgt_var_sk.;

	proc sql;

	update &m_src_lib..bin_chrstc_filter_dtl
	set filter_operand_variable_sk = &m_tgt_var_sk.

	where bin_chrstc_sk in (&m_bin_chrstc_sk_lst.)

	;
	quit;
	
	
	%let m_bin_chrstc_sk_lst2=.;
	proc sql;

	select 
		bin_chrstc_sk into  :m_bin_chrstc_sk_lst2 separated by ','  /* i18nOK:Line */
	from 
		&m_src_lib..model_x_scorecard_chrstc
		
	where model_sk=&m_model_sk. ;

	quit;

	%let m_bin_chrstc_sk_lst2 = &m_bin_chrstc_sk_lst2.;
	
	proc sql;

	update &m_src_lib..bin_chrstc_filter_dtl
	set filter_operand_variable_sk = &m_tgt_var_sk.

	where bin_chrstc_sk in (&m_bin_chrstc_sk_lst2.)

	;
	quit;
	
	/*End of Update tgt var sk*/
	
	%if %kupcase("&DABT_RETAIN_APPL_SCRATCH_FLG") eq "N" %then %do; /* i18nOK:Line */
		proc sql noprint;
			drop table &m_tmp_lib..lst_impl_var_sk;
			drop table &m_tmp_lib..lst_impl_var_nm;
		quit;
	%end;
		
	/* End: Insert implicit variable for scoring and actual */
	
	%dabt_set_bin_scheme_flg(m_model_sk=&m_model_sk.);
	
	/* Set the status for dev data load */
	%dabt_intrfc_set_load_dev_status(m_model_sk=&m_model_sk, m_status_cd=NOT_READY);
	
	/* This macro variable will be assigned the value N, if the post action macro executes without error,
		 else will have value Y. */
	%let post_action_err_flg = ;
	%dabt_call_post_action_macro(m_action_cd=NEW_MDL, m_purpose_sk=&m_purpose_sk,
								m_model_sk=&m_model_sk, m_post_action_flg=post_action_err_flg);

	/********************************* RPM Model ****************************/
	%if &m_model_source_type_cd eq RPM %then %do;
		
		%dabt_create_register_rpm_model(m_model_sk=&m_model_sk, m_metadata_folder_path=%quote(&m_metadata_folder_path),
						m_log_path=%quote(&m_log_path), m_log_file_nm=%quote(&m_log_file_nm),m_created_by_user=%quote(&m_created_by_user));
	%end;


	/********************************* RPM Model ****************************/

	
%mend dabt_new_model_wrapper;
